@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
SET Param0=%0
SET Param1=%1
SET Param2=%2
SET Param3="%~3"
SET Param4="%~4"
IF %1.==. GOTO :Error
IF NOT EXIST %1 GOTO :Error
IF %2.==. GOTO :Error
SET Archive="%~dpnx1"
SET Archive_Name=%~n1
SET Program=wbzip_new.exe
FOR %%A IN ( /L /LS /XA /XF /XS /XSF ) DO IF /I %2.==%%A. GOTO :%2
GOTO :Error

:/L
SET /A Counter=0
ECHO.
ECHO # - Section(s)	- File(s)
ECHO _________________________________________________
ECHO.
FOR /F "tokens=* delims=" %%? IN ('more %Archive% ^|FINDSTR /B /I "[EncodedFile-" 2^>nul') DO (
SET Full_Section=%%?
CALL :Parse_Section_with_stupid_filenames
CALL :Parse_Files !Only_Section! !File_Name!
)
ECHO.
GOTO :EOF

:/LS
SET /A Counter=0
ECHO.
ECHO # - Section(s)
ECHO ________________
ECHO.
FOR /F "tokens=2,3 delims=-]" %%A IN ('more %Archive% ^|FINDSTR /B /I "[EncodedFile-" 2^>nul') DO CALL :Parse_Sections "%%A" "%%B"
ECHO.
GOTO :EOF

:/XA
IF %3.==. (Set Target="%~dp0") ELSE (SET Target="%~3")
IF NOT %Target:~-2,1%==\ SET Target="%~3\" 
DIR %Target% | FIND ".." >nul||GOTO :Error
ECHO Source: %Archive%
ECHO Target: %Target%
ECHO.
FOR /F "tokens=* delims=" %%? IN ('more %Archive% ^|FINDSTR /B /I "[EncodedFile-" 2^>nul') DO (
SET Full_Section=%%?
CALL :Parse_Section_with_stupid_filenames
CALL :Parse_Files !Only_Section! !File_Name!
)
ECHO.
FOR /F "tokens=2,3 delims==" %%A in ('SET EncodedFile') DO CALL :Do_Extract %%A
GOTO :EOF

:/XF
IF %3.==. GOTO :ERROR
IF %4.==. (Set Target="%~dp0") ELSE (SET Target="%~4")
IF NOT %Target:~-2,1%==\ SET Target="%~4\" 
DIR %Target% | FIND ".." >nul||GOTO :Error
ECHO Source: %Archive%
ECHO Target: %Target%
ECHO.
FOR /F "tokens=* delims=" %%? IN ('more %Archive% ^|FINDSTR /B /I "[EncodedFile-" 2^>nul') DO (
SET Full_Section=%%?
CALL :Parse_Section_with_stupid_filenames
CALL :Parse_Files !Only_Section! !File_Name!
)
ECHO.
FOR /F "tokens=2,3 delims==" %%A in ('SET EncodedFile') DO (
IF /I %%B.==%Param3%. CALL :Do_Extract %%A
)
GOTO :EOF

:/XS
IF %3.==. GOTO :ERROR
IF %4.==. (Set Target="%~dp0") ELSE (SET Target="%~4")
IF NOT %Target:~-2,1%==\ SET Target="%~4\" 
DIR %Target% | FIND ".." >nul||GOTO :Error
ECHO Source: %Archive%
ECHO Target: %Target%
ECHO.
FOR /F "tokens=* delims=" %%? IN ('more %Archive% ^|FINDSTR /B /I "[EncodedFile-" 2^>nul') DO (
SET Full_Section=%%?
CALL :Parse_Section_with_stupid_filenames
IF /I !Only_Section!.==%Param3%. CALL :Parse_Files !Only_Section! !File_Name!
)
ECHO.
FOR /F "tokens=2,3 delims==" %%A in ('SET EncodedSection') DO IF /I %%B.==%Param3%. CALL :Do_Extract %%A
GOTO :EOF


:/XSF
IF %3.==. GOTO :ERROR
IF %4.==. GOTO :ERROR
IF %5.==. (Set Target="%~dp0") ELSE (SET Target="%~5")
IF NOT %Target:~-2,1%==\ SET Target="%~5\"
DIR %Target% | FIND ".." >nul||GOTO :Error
ECHO Source: %Archive%
ECHO Target: %Target%
ECHO.
FOR /F "tokens=* delims=" %%? IN ('more %Archive% ^|FINDSTR /B /I "[EncodedFile-" 2^>nul') DO (
SET Full_Section=%%?
CALL :Parse_Section_with_stupid_filenames
IF /I !Only_Section!.==%Param3%. CALL :Parse_Files !Only_Section! !File_Name!
)
ECHO.
FOR /F "tokens=2,3 delims==" %%A in ('SET EncodedFile') DO (
IF /I !EncodedSection%%A!.==%Param3%. IF /I %%B.==%Param4%. CALL :Do_Extract %%A
)
GOTO :EOF


:Parse_Files
SET /A Counter+=1
SET EncodedSection%Counter%=%1
SET EncodedFile%Counter%=%2
ECHO %Counter% - %1	- %2
GOTO :EOF

:Parse_Files_in_Section
SET /A Counter+=1
SET EncodedSection%Counter%=%1
SET EncodedFile%Counter%=%2
ECHO %Counter% - %1	- %2
GOTO :EOF

:Parse_Sections
SET /A Counter+=1
SET EncodedSection%Counter%=%1
IF %Counter% gtr 0 SET /A Previous=%Counter%-1
IF !EncodedSection%Counter%!.==!EncodedSection%Previous%!. (SET /A Counter-=1) ELSE (ECHO %Counter% - %1)
GOTO :EOF

:Parse_Section_with_stupid_filenames
FOR /F "tokens=1,2,* delims=-" %%B IN ("%FULL_SECTION%") DO (
SET Only_Section="%%C"
SET File_Name="%%D"
SET File_Name=!File_Name:]=!
)
GOTO :EOF

:Do_Extract
SET NewTarget=%Target:~0,-1%%Archive_Name%.contents\"
IF NOT EXIST %NewTarget% MD %NewTarget%
SET Subdir=!EncodedSection%1:"=!
SET NewTarget=%NewTarget:~0,-1%%SubDir%\"
IF NOT EXIST %NewTarget% MD %NewTarget%
%Program% -x %Archive% !EncodedSection%1! !EncodedFile%1! %NewTarget%>nul&&ECHO File %1 - !EncodedFile%1! Extracted succesfully
GOTO :EOF



:Error
CLS
ECHO A parameter is missing or incorrect, you typed:
ECHO %Param0% %Param1% %Param2% %Param3% %Param4%
ECHO.
CALL :Usage
GOTO :EOF




:Usage
ECHO unwbzip.cmd simple batch to help in using wbzip.exe or wbzip_new.exe
ECHO             to extract files embedded in Winbuilder .scripts
ECHO             Release ALPHA 0.06 08/April/2010 by jaclaz
ECHO             ****************************************************
ECHO             **paths with spaces in them may be supported , NOW**
ECHO             ****************************************************
ECHO.
ECHO Usage:
ECHO unwbzip ^<scriptname.script^> [options] [^<section^> ^<filename^>] [TargetDir]
ECHO.
ECHO Options:
ECHO /L                        - List all filenames of files encoded in .script
ECHO /LS                       - List all Sections of files encoded in .script
ECHO /XA                       - eXtract All files encoded in .script
ECHO /XF  ^<filename^>           - eXtract File ^<filename^> regardless of it's Section
ECHO /XS  ^<section^>            - eXtract All files contained in  ^<Section^> only
ECHO /XSF ^<section^> ^<filename^> - eXtract ^<Filename^> from ^<Section^> only
GOTO :EOF
REM...
REM Approach is to "grep" the file looking for the headers of the "[EncodedFile-" and parse the name (fixing it for a name with "-" in it
REM so that it can get the name and section (folder) it is in.  Then if a specific file is to be extracted, when going through the list of ALL
REM files, instead of printing them, if getting specific files, it looks for a match on file name, section, or both. If a "match", then call the extract
REM...